Program Shorty;
Uses Dos;

Type BufferType = Array[0..1024*25] of Char;

Var LogfileName : ComStr;
    LogFilePath : ComStr;
    FileSizeStr : String;
    MaxSize     : LongInt;
    CurrSize    : LongInt;
    InpBuffer   : BufferType;
    OutBuffer   : BufferType;
    Search      : SearchRec;

Procedure GrabParameters;
Var Stop : Boolean;
    C    : Byte;
Begin
If ParamCount=0
   Then Begin
        WriteLn('Syntax: Shorty <FileName> <Max. FileSize>');
        WriteLn('  Filesize can given in bytes, KBytes or MBytes.');
        WriteLn('  F.e. 1000, 10Kb or 1Mb');
        Halt;
        End;

LogFileName:=FExpand(ParamStr(1));
LogFilePath:=LogFileName;
While (LogFilePath<>'') And (LogFilePath[Length(LogFilePath)]<>'\') Do
 Dec(LogFilePath[0]);

FileSizeStr:=ParamStr(2);
Stop:=False;
C:=1;
MaxSize:=0;
While Not Stop Do
 Begin
 Case Upcase(FileSizeStr[C]) Of
  '0'..'9' : MaxSize:=(MaxSize*10)+(Ord(fileSizeStr[C])-48);
  'K'      : MaxSize:=MaxSize*1024;
  'M'      : MaxSize:=MaxSize*(1024*1024);
 End; {case}
 Stop:=(C=Length(FileSizeStr)) Or (FileSizeStr[C] in ['K','M']);
 Inc(C);
 End; {While}
End;

Function SeekTxt(Var F : Text;ToPtr : LongInt):LongInt;
Var Regs : Registers;
Begin
With Regs Do
 Begin
 AH:=$42;  AL:=$00;
 BX:=TextRec(F).Handle;
 CX:=(ToPtr And $FFFF0000) Shr 16;
 DX:=ToPtr And $0000FFFF;
 MsDos(Regs);
 SeekTxt:=(LongInt(DX) Shl 16)+LongInt(AX);
 End;
End;


Procedure HandleLogFile(FilePath,FileName : ComStr);
Var Tmp      : Text;
    Out      : Text;
    Line     : String;
    Check    : LongInt;
    TmpName  : ComStr;

Begin
FilePath:=FilePath+FileName;

TmpName:=FilePath;
If Pos('.',TmpName)>0
   Then TmpName:=Copy(TmpName,1,Pos('.',TmpName)-1);
TmpName:=TmpName+'.$T$';

Assign(Tmp,FilePath);
SetTextBuf(Tmp,InpBuffer);
Reset(Tmp);
If IoResult<>0
   Then Begin
        WriteLn(' - Couldn''t open input file.');
        Exit;
        End;

Assign(Out,TmpName);
SetTextBuf(Tmp,OutBuffer);
Rewrite(Out);
If IoResult<>0
   Then Begin
        Close(Tmp);
        WriteLn('  - ERROR: Couldn''t open tmpfile.');
        Exit;
        End;

Check:=0;
If (CurrSize-MaxSize)>(5*1024)
   Then Check:=SeekTxt(Tmp,CurrSize-(MaxSize+(5*1024)));

While Not Eof(Tmp) Do
 Begin
 ReadLn(Tmp,Line);
 Inc(Check,Length(Line)+2);  { + Cr Lf}
 Write(CurrSize-Check:7,'/',MaxSize,#13'  ',FileName,'':12-Length(FileName));
 If (CurrSize-Check)<MaxSize
    Then Begin
          WriteLn(Out,Line);
         If IoResult<>0
            Then Begin
                 Close(Tmp);
                 Close(Out);
                 Erase(Out);
                 WriteLn(' - Not enough space free on disk.');
                 If IoResult<>0
                    Then Halt(1);
                 Exit;
                 End;
         End;
 End;
Close(Tmp);
Close(Out);
If IoResult<>0
   Then;
Erase(Tmp);
Rename(Out,FilePath);
If IoResult<>0
   Then WriteLn(' - Couldn''t rename tmp. file.')
   Else WriteLn;

End;



Begin
WriteLn('Shorty 1.0, LiveSystems Truncating utility. Released 3 Jan 1995');
WriteLn('Donated to the public domain.');
WriteLn;
GrabParameters;
FindFirst(LogFileName,Anyfile,Search);
Write('  ',Search.Name,'':12-Length(Search.Name));
CurrSize:=Search.Size;
If (CurrSize-255)>=MaxSize    { Maximal 1 string more! }
   Then HandleLogFile(LogFilePath,Search.Name)
   Else WriteLn(' - Ok');
End.